Index: pjproject/trunk/aconfigure
===================================================================
--- pjproject/trunk/aconfigure	(revision 4107)
+++ pjproject/trunk/aconfigure	(revision 4108)
@@ -6635,7 +6635,6 @@
   { { $as_echo "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
 $as_echo "$as_me: error: in \`$ac_pwd':" >&2;}
-{ as_fn_set_status run with --help for more info
-as_fn_error "Error: unable to recognize your IPP installation. Make sure the paths and ARCH suffix are set correctly
-See \`config.log' for more details." "$LINENO" 5; }; }
+as_fn_error "Error: unable to recognize your IPP installation. Make sure the paths and ARCH suffix are set correctly, run with --help for more info
+See \`config.log' for more details." "$LINENO" 5; }
 fi
 rm -f core conftest.err conftest.$ac_objext \
Index: pjproject/trunk/aconfigure.ac
===================================================================
--- pjproject/trunk/aconfigure.ac	(revision 4107)
+++ pjproject/trunk/aconfigure.ac	(revision 4108)
@@ -1112,5 +1112,5 @@
 					   [ippStaticInit();])],
 		  [AC_MSG_RESULT(ok)],
-		  [AC_MSG_FAILURE(Error: unable to recognize your IPP installation. Make sure the paths and ARCH suffix are set correctly, run with --help for more info)])
+		  [AC_MSG_FAILURE([Error: unable to recognize your IPP installation. Make sure the paths and ARCH suffix are set correctly, run with --help for more info])])
 
 	CFLAGS="$SAVED_CFLAGS"
Index: pjproject/trunk/pjlib/src/pjlib-test/udp_echo_srv_ioqueue.c
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/udp_echo_srv_ioqueue.c	(revision 4107)
+++ pjproject/trunk/pjlib/src/pjlib-test/udp_echo_srv_ioqueue.c	(revision 4108)
@@ -23,4 +23,5 @@
 static pj_ioqueue_key_t *key;
 static pj_atomic_t *total_bytes;
+static pj_bool_t thread_quit_flag;
 
 struct op_key
@@ -146,10 +147,10 @@
     }
     
-    for (;;) {
+    while (!thread_quit_flag) {
         pj_time_val timeout;
         timeout.sec = 0; timeout.msec = 10;
         rc = pj_ioqueue_poll(ioqueue, &timeout);
     }
-    PJ_UNREACHED(return 0;)
+    return 0;
 }
 
Index: pjproject/trunk/pjlib/src/pjlib-test/udp_echo_srv_sync.c
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/udp_echo_srv_sync.c	(revision 4107)
+++ pjproject/trunk/pjlib/src/pjlib-test/udp_echo_srv_sync.c	(revision 4108)
@@ -22,4 +22,5 @@
 
 static pj_atomic_t *total_bytes;
+static pj_bool_t thread_quit_flag = 0;
 
 static int worker_thread(void *arg)
@@ -29,5 +30,5 @@
     pj_status_t  last_recv_err = PJ_SUCCESS, last_write_err = PJ_SUCCESS;
 
-    for (;;) {
+    while (!thread_quit_flag) {
         pj_ssize_t len;
         pj_status_t rc;
@@ -57,5 +58,5 @@
         }
     }
-    PJ_UNREACHED(return 0;)
+    return 0;
 }
 
Index: pjproject/trunk/pjmedia/src/pjmedia/stream.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/stream.c	(revision 4107)
+++ pjproject/trunk/pjmedia/src/pjmedia/stream.c	(revision 4108)
@@ -962,5 +962,5 @@
         			     "Error generating RTCP SDES"));
 	} else {
-	    len += sdes_len;
+	    len += (int)sdes_len;
 	}
     }
@@ -1020,5 +1020,5 @@
         			     "Error generating RTCP BYE"));
 	} else {
-	    len += bye_len;
+	    len += (int)bye_len;
 	}
     }
Index: pjproject/trunk/pjsip/src/pjsip/sip_resolve.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_resolve.c	(revision 4107)
+++ pjproject/trunk/pjsip/src/pjsip/sip_resolve.c	(revision 4108)
@@ -264,6 +264,12 @@
 	    count = 1;
 	    status = pj_getaddrinfo(af, &target->addr.host, &count, &ai);
-	    if (status != PJ_SUCCESS)
+	    if (status != PJ_SUCCESS) {
+		/* "Normalize" error to PJ_ERESOLVE. This is a special error
+		 * because it will be translated to SIP status 502 by
+		 * sip_transaction.c
+		 */
+		status = PJ_ERESOLVE;
 		goto on_error;
+	    }
 
 	    svr_addr.entry[0].addr.addr.sa_family = (pj_uint16_t)af;